Index: trunk/src/VBox/Frontends/VirtualBox/src/extensions/QIMessageBox.cpp
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox/src/extensions/QIMessageBox.cpp	(revision 89927)
+++ trunk/src/VBox/Frontends/VirtualBox/src/extensions/QIMessageBox.cpp	(revision 89928)
@@ -313,5 +313,4 @@
         case AlertButton_Choice2: strText = tr("No");     role = QDialogButtonBox::NoRole; break;
         case AlertButton_Copy:    strText = tr("Copy");   role = QDialogButtonBox::ActionRole; break;
-        case AlertButton_Help:    strText = tr("Copy");   role = QDialogButtonBox::HelpRole; break;
         default:
             AssertMsgFailed(("Type %d is not supported!", iButton));
Index: trunk/src/VBox/Frontends/VirtualBox/src/extensions/QIMessageBox.h
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox/src/extensions/QIMessageBox.h	(revision 89927)
+++ trunk/src/VBox/Frontends/VirtualBox/src/extensions/QIMessageBox.h	(revision 89928)
@@ -47,5 +47,4 @@
     AlertButton_Choice2       =  0x8,  /* 00000000 00001000 */
     AlertButton_Copy          = 0x10,  /* 00000000 00010000 */
-    AlertButton_Help          = 0x11,  /* 00000000 00010001 */
     AlertButtonMask           = 0xFF   /* 00000000 11111111 */
 };
Index: trunk/src/VBox/Frontends/VirtualBox/src/globals/UIMessageCenter.cpp
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox/src/globals/UIMessageCenter.cpp	(revision 89927)
+++ trunk/src/VBox/Frontends/VirtualBox/src/globals/UIMessageCenter.cpp	(revision 89928)
@@ -160,9 +160,7 @@
                              int iButton2 /* = 0*/,
                              int iButton3 /* = 0*/,
-                             int iButton4 /* = 0*/,
                              const QString &strButtonText1 /* = QString() */,
                              const QString &strButtonText2 /* = QString() */,
-                             const QString &strButtonText3 /* = QString() */,
-                             const QString &strButtonText4 /* = QString() */) const
+                             const QString &strButtonText3 /* = QString() */) const
 {
     /* If this is NOT a GUI thread: */
@@ -173,6 +171,6 @@
         emit sigToShowMessageBox(pParent, enmType,
                                  strMessage, strDetails,
-                                 iButton1, iButton2, iButton3, iButton4,
-                                 strButtonText1, strButtonText2, strButtonText3, strButtonText4,
+                                 iButton1, iButton2, iButton3,
+                                 strButtonText1, strButtonText2, strButtonText3,
                                  QString(pcszAutoConfirmId));
         /* Inter-thread communications are not yet implemented: */
@@ -207,9 +205,7 @@
                     AlertButton_Cancel | AlertButtonOption_Escape,
                     0 /* third button */,
-                    0 /* fourth button */,
                     strOkButtonText,
                     strCancelButtonText,
-                    QString() /* third button */,
-                    QString() /* fourth button */) &
+                    QString() /* third button */) &
             AlertButtonMask) == AlertButton_Ok;
 }
@@ -228,12 +224,10 @@
                               int iButton2 /* = 0*/,
                               int iButton3 /* = 0*/,
-                              int iButton4 /* = 0*/,
                               const QString &strButtonText1 /* = QString()*/,
                               const QString &strButtonText2 /* = QString()*/,
-                              const QString &strButtonText3 /* = QString()*/,
-                              const QString &strButtonText4 /* = QString()*/) const
+                              const QString &strButtonText3 /* = QString()*/) const
 {
     return message(pParent, enmType, strMessage, QString(), pcszAutoConfirmId,
-                   iButton1, iButton2, iButton3, iButton4, strButtonText1, strButtonText2, strButtonText3, strButtonText4);
+                   iButton1, iButton2, iButton3, strButtonText1, strButtonText2, strButtonText3);
 }
 
@@ -250,9 +244,7 @@
                       AlertButton_Cancel | AlertButtonOption_Escape,
                       0 /* third button */,
-                      0 /* fourth button */,
                       strOkButtonText,
                       strCancelButtonText,
-                      QString() /* third button */,
-                      QString() /* fourth button */) &
+                      QString() /* third button */) &
              AlertButtonMask) == AlertButton_Ok) :
            ((question(pParent, enmType, strMessage, pcszAutoConfirmId,
@@ -260,9 +252,7 @@
                       AlertButton_Cancel | AlertButtonOption_Default | AlertButtonOption_Escape,
                       0 /* third button */,
-                      0 /* fourth button */,
                       strOkButtonText,
                       strCancelButtonText,
-                      QString() /* third button */,
-                      QString() /* fourth button */) &
+                      QString() /* third button */) &
              AlertButtonMask) == AlertButton_Ok);
 }
@@ -279,9 +269,7 @@
                     AlertButton_Choice2 | AlertButtonOption_Default,
                     AlertButton_Cancel | AlertButtonOption_Escape,
-                    0 /* fourth button */,
                     strChoice1ButtonText,
                     strChoice2ButtonText,
-                    strCancelButtonText,
-                    QString() /* fourth button text*/);
+                    strCancelButtonText);
 }
 
@@ -293,12 +281,10 @@
                                        int iButton2 /* = 0*/,
                                        int iButton3 /* = 0*/,
-                                       int iButton4 /* = 0*/,
                                        const QString &strButtonName1 /* = QString() */,
                                        const QString &strButtonName2 /* = QString() */,
-                                       const QString &strButtonName3 /* = QString() */,
-                                       const QString &strButtonName4 /* = QString() */) const
+                                       const QString &strButtonName3 /* = QString() */) const
 {
     /* If no buttons are set, using single 'OK' button: */
-    if (iButton1 == 0 && iButton2 == 0 && iButton3 == 0 && iButton4 == 0)
+    if (iButton1 == 0 && iButton2 == 0 && iButton3 == 0)
         iButton1 = AlertButton_Ok | AlertButtonOption_Default;
 
@@ -355,6 +341,4 @@
     if (!strButtonName3.isNull())
         pBox->setButtonText(2, strButtonName3);
-    if (!strButtonName4.isNull())
-        pBox->setButtonText(3, strButtonName4);
 
     /* Show box: */
@@ -778,6 +762,5 @@
                    AlertButton_Ok,
                    AlertButton_Cancel | AlertButtonOption_Default | AlertButtonOption_Escape,
-                   0 /* button 3 */,
-                   0 /* button 4 */,
+                   0,
                    tr("Remove")) :
            message(0, MessageType_Question,
@@ -787,5 +770,4 @@
                    AlertButton_Choice2,
                    AlertButton_Cancel | AlertButtonOption_Default | AlertButtonOption_Escape,
-                   0 /* button 4 */,
                    tr("Delete all files"),
                    tr("Remove only"));
@@ -816,5 +798,4 @@
                    AlertButton_Choice2,
                    AlertButton_Cancel | AlertButtonOption_Default | AlertButtonOption_Escape,
-                   0 /* button 4 */,
                    tr("Delete everything"),
                    tr("Remove only"));
@@ -1146,5 +1127,4 @@
                              AlertButton_Cancel | AlertButtonOption_Default | AlertButtonOption_Escape,
                              0 /* 3rd button */,
-                             0 /* 4th button */,
                              tr("Restore"), tr("Cancel"), QString() /* 3rd button text */) :
            message(0, MessageType_Question,
@@ -1156,5 +1136,4 @@
                    AlertButton_Cancel | AlertButtonOption_Default | AlertButtonOption_Escape,
                    0 /* 3rd button */,
-                   0 /* 4th button */,
                    tr("Restore"), tr("Cancel"), QString() /* 3rd button text */);
 }
@@ -2238,5 +2217,4 @@
                     AlertButton_Choice2,
                     AlertButton_Cancel | AlertButtonOption_Default | AlertButtonOption_Escape,
-                    0 /* 4th button */,
                     tr("Accept", "cloud profile manager changes"),
                     tr("Reject", "cloud profile manager changes"));
@@ -2775,6 +2753,5 @@
                       AlertButton_Ok | AlertButtonOption_Default,
                       AlertButton_Cancel | AlertButtonOption_Escape,
-                      0 /* 3rd button */,
-                      0 /* 4th button */,
+                      0,
                       tr("Capture", "do input capture"));
     /* Was the message auto-confirmed? */
Index: trunk/src/VBox/Frontends/VirtualBox/src/globals/UIMessageCenter.h
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox/src/globals/UIMessageCenter.h	(revision 89927)
+++ trunk/src/VBox/Frontends/VirtualBox/src/globals/UIMessageCenter.h	(revision 89928)
@@ -71,15 +71,12 @@
       * @param  iButton2          Brings the button 2 type.
       * @param  iButton3          Brings the button 3 type.
-      * @param  iButton4          Brings the button 4 type.
       * @param  strButtonText1    Brings the button 1 text.
       * @param  strButtonText2    Brings the button 2 text.
       * @param  strButtonText3    Brings the button 3 text.
-      * @param  strButtonText4    Brings the button 4 text.
       * @param  strAutoConfirmId  Brings whether this message can be auto-confirmed. */
     void sigToShowMessageBox(QWidget *pParent, MessageType enmType,
                              const QString &strMessage, const QString &strDetails,
-                             int iButton1, int iButton2, int iButton3, int iButton4,
-                             const QString &strButtonText1, const QString &strButtonText2,
-                             const QString &strButtonText3, const QString &strButtonText4,
+                             int iButton1, int iButton2, int iButton3,
+                             const QString &strButtonText1, const QString &strButtonText2, const QString &strButtonText3,
                              const QString &strAutoConfirmId) const;
 
@@ -105,17 +102,14 @@
       * @param  iButton2           Brings the button 2 type.
       * @param  iButton3           Brings the button 3 type.
-      * @param  iButton4           Brings the button 4 type.
       * @param  strButtonText1     Brings the button 1 text.
       * @param  strButtonText2     Brings the button 2 text.
-      * @param  strButtonText3     Brings the button 3 text.
-      * @param  strButtonText3     Brings the button 4 text. */
+      * @param  strButtonText3     Brings the button 3 text. */
     int message(QWidget *pParent, MessageType enmType,
                 const QString &strMessage, const QString &strDetails,
                 const char *pcszAutoConfirmId = 0,
-                int iButton1 = 0, int iButton2 = 0, int iButton3 = 0, int iButton4 = 0,
+                int iButton1 = 0, int iButton2 = 0, int iButton3 = 0,
                 const QString &strButtonText1 = QString(),
                 const QString &strButtonText2 = QString(),
-                const QString &strButtonText3 = QString(),
-                const QString &strButtonText4 = QString()) const;
+                const QString &strButtonText3 = QString()) const;
 
     /** Shows an 'Error' type of 'Message'.
@@ -166,17 +160,14 @@
       * @param  iButton2           Brings the button 2 type.
       * @param  iButton3           Brings the button 3 type.
-      * @param  iButton4           Brings the button 4 type.
       * @param  strButtonText1     Brings the button 1 text.
       * @param  strButtonText2     Brings the button 2 text.
-      * @param  strButtonText3     Brings the button 3 text.
-      * @param  strButtonText4     Brings the button 4 text. */
+      * @param  strButtonText3     Brings the button 3 text. */
     int question(QWidget *pParent, MessageType enmType,
                  const QString &strMessage,
                  const char *pcszAutoConfirmId = 0,
-                 int iButton1 = 0, int iButton2 = 0, int iButton3 = 0, int iButton4 = 0,
+                 int iButton1 = 0, int iButton2 = 0, int iButton3 = 0,
                  const QString &strButtonText1 = QString(),
                  const QString &strButtonText2 = QString(),
-                 const QString &strButtonText3 = QString(),
-                 const QString &strButtonText4 = QString()) const;
+                 const QString &strButtonText3 = QString()) const;
 
     /** Shows a 'Binary' type of 'Question'.
@@ -221,5 +212,4 @@
       * @param  iButton2             Brings the button 2 type.
       * @param  iButton3             Brings the button 3 type.
-      * @param  iButton4             Brings the button 4 type.
       * @param  strButtonText1       Brings the button 1 text.
       * @param  strButtonText2       Brings the button 2 text.
@@ -229,9 +219,8 @@
                           const QString &strOptionText,
                           bool fDefaultOptionValue = true,
-                          int iButton1 = 0, int iButton2 = 0, int iButton3 = 0, int iButton4 = 0,
+                          int iButton1 = 0, int iButton2 = 0, int iButton3 = 0,
                           const QString &strButtonText1 = QString(),
                           const QString &strButtonText2 = QString(),
-                          const QString &strButtonText3 = QString(),
-                          const QString &strButtonText4 = QString()) const;
+                          const QString &strButtonText3 = QString()) const;
 
     /** Shows modal progress-dialog.