Index: trunk/src/VBox/Frontends/VirtualBox/src/extensions/QIMessageBox.cpp
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox/src/extensions/QIMessageBox.cpp	(revision 89946)
+++ trunk/src/VBox/Frontends/VirtualBox/src/extensions/QIMessageBox.cpp	(revision 89950)
@@ -39,6 +39,7 @@
 
 
-QIMessageBox::QIMessageBox(const QString &strTitle, const QString &strMessage, const QString &strHelpKeyword, AlertIconType iconType,
-                           int iButton1 /* = 0*/, int iButton2 /* = 0*/, int iButton3 /* = 0*/, QWidget *pParent /* = 0*/)
+QIMessageBox::QIMessageBox(const QString &strTitle, const QString &strMessage, AlertIconType iconType,
+                           int iButton1 /* = 0*/, int iButton2 /* = 0*/, int iButton3 /* = 0*/, QWidget *pParent /* = 0*/,
+                           const QString &strHelpKeyword /* = QString() */)
     : QIDialog(pParent)
     , m_strTitle(strTitle)
Index: trunk/src/VBox/Frontends/VirtualBox/src/extensions/QIMessageBox.h
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox/src/extensions/QIMessageBox.h	(revision 89946)
+++ trunk/src/VBox/Frontends/VirtualBox/src/extensions/QIMessageBox.h	(revision 89950)
@@ -97,6 +97,7 @@
       * @param  iButton2    Brings the integer-code for the 2nd button.
       * @param  iButton3    Brings the integer-code for the 3rd button. */
-    QIMessageBox(const QString &strTitle, const QString &strMessage, const QString &strHelpKeyword, AlertIconType iconType,
-                 int iButton1 = 0, int iButton2 = 0, int iButton3 = 0, QWidget *pParent = 0);
+    QIMessageBox(const QString &strTitle, const QString &strMessage, AlertIconType iconType,
+                 int iButton1 = 0, int iButton2 = 0, int iButton3 = 0, QWidget *pParent = 0,
+                 const QString &strHelpKeyword = QString());
 
     /** Defines details-text. */
Index: trunk/src/VBox/Frontends/VirtualBox/src/extradata/UIExtraDataManager.cpp
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox/src/extradata/UIExtraDataManager.cpp	(revision 89946)
+++ trunk/src/VBox/Frontends/VirtualBox/src/extradata/UIExtraDataManager.cpp	(revision 89950)
@@ -916,5 +916,4 @@
             if (!msgCenter().questionBinary(this, MessageType_Question,
                                             QString("Overwriting already existing key, Continue?"),
-                                            QString() /* help keyword */,
                                             0 /* auto-confirm id */,
                                             QString("Overwrite") /* ok button text */,
@@ -1107,5 +1106,4 @@
             if (!msgCenter().questionBinary(this, MessageType_Question,
                                             QString("Overwriting already existing key, Continue?"),
-                                            QString() /* help keyword */,
                                             0 /* auto-confirm id */,
                                             QString("Overwrite") /* ok button text */,
@@ -1153,6 +1151,5 @@
                                        QString("<p>Do you really wish to "
                                                "remove chosen records?</p>"),
-                                       strDetails,
-                                       QString() /* help keyword */))
+                                       strDetails))
         return;
 
Index: trunk/src/VBox/Frontends/VirtualBox/src/globals/UIMessageCenter.cpp
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox/src/globals/UIMessageCenter.cpp	(revision 89946)
+++ trunk/src/VBox/Frontends/VirtualBox/src/globals/UIMessageCenter.cpp	(revision 89950)
@@ -156,5 +156,4 @@
                              const QString &strMessage,
                              const QString &strDetails,
-                             const QString &strHelpKeyword,
                              const char *pcszAutoConfirmId /* = 0*/,
                              int iButton1 /* = 0*/,
@@ -171,5 +170,5 @@
          * to show a message-box in the GUI thread: */
         emit sigToShowMessageBox(pParent, enmType,
-                                 strMessage, strDetails, strHelpKeyword,
+                                 strMessage, strDetails,
                                  iButton1, iButton2, iButton3,
                                  strButtonText1, strButtonText2, strButtonText3,
@@ -180,5 +179,5 @@
     /* In usual case we can chow a message-box directly: */
     return showMessageBox(pParent, enmType,
-                          strMessage, strDetails, strHelpKeyword,
+                          strMessage, strDetails,
                           iButton1, iButton2, iButton3,
                           strButtonText1, strButtonText2, strButtonText3,
@@ -189,8 +188,7 @@
                            const QString &strMessage,
                            const QString &strDetails,
-                           const QString &strHelpKeyword  /* = QString() */,
                            const char *pcszAutoConfirmId /* = 0*/) const
 {
-    message(pParent, enmType, strMessage, strDetails, strHelpKeyword, pcszAutoConfirmId,
+    message(pParent, enmType, strMessage, strDetails, pcszAutoConfirmId,
             AlertButton_Ok | AlertButtonOption_Default | AlertButtonOption_Escape);
 }
@@ -199,10 +197,9 @@
                                         const QString &strMessage,
                                         const QString &strDetails,
-                                        const QString &strHelpKeyword,
                                         const char *pcszAutoConfirmId /* = 0*/,
                                         const QString &strOkButtonText /* = QString()*/,
                                         const QString &strCancelButtonText /* = QString()*/) const
 {
-    return (message(pParent, enmType, strMessage, strDetails, strHelpKeyword, pcszAutoConfirmId,
+    return (message(pParent, enmType, strMessage, strDetails, pcszAutoConfirmId,
                     AlertButton_Ok | AlertButtonOption_Default,
                     AlertButton_Cancel | AlertButtonOption_Escape,
@@ -223,5 +220,4 @@
 int UIMessageCenter::question(QWidget *pParent, MessageType enmType,
                               const QString &strMessage,
-                              const QString &strHelpKeyword,
                               const char *pcszAutoConfirmId/* = 0*/,
                               int iButton1 /* = 0*/,
@@ -232,5 +228,5 @@
                               const QString &strButtonText3 /* = QString()*/) const
 {
-    return message(pParent, enmType, strMessage, QString()  /* details */, strHelpKeyword, pcszAutoConfirmId,
+    return message(pParent, enmType, strMessage, QString(), pcszAutoConfirmId,
                    iButton1, iButton2, iButton3, strButtonText1, strButtonText2, strButtonText3);
 }
@@ -238,5 +234,4 @@
 bool UIMessageCenter::questionBinary(QWidget *pParent, MessageType enmType,
                                      const QString &strMessage,
-                                     const QString &strHelpKeyword /* = QString() */,
                                      const char *pcszAutoConfirmId /* = 0*/,
                                      const QString &strOkButtonText /* = QString()*/,
@@ -245,5 +240,5 @@
 {
     return fDefaultFocusForOk ?
-           ((question(pParent, enmType, strMessage, strHelpKeyword, pcszAutoConfirmId,
+           ((question(pParent, enmType, strMessage, pcszAutoConfirmId,
                       AlertButton_Ok | AlertButtonOption_Default,
                       AlertButton_Cancel | AlertButtonOption_Escape,
@@ -253,5 +248,5 @@
                       QString() /* third button */) &
              AlertButtonMask) == AlertButton_Ok) :
-           ((question(pParent, enmType, strMessage, strHelpKeyword, pcszAutoConfirmId,
+           ((question(pParent, enmType, strMessage, pcszAutoConfirmId,
                       AlertButton_Ok,
                       AlertButton_Cancel | AlertButtonOption_Default | AlertButtonOption_Escape,
@@ -265,5 +260,4 @@
 int UIMessageCenter::questionTrinary(QWidget *pParent, MessageType enmType,
                                      const QString &strMessage,
-                                     const QString &strHelpKeyword /* = QString() */,
                                      const char *pcszAutoConfirmId /* = 0*/,
                                      const QString &strChoice1ButtonText /* = QString()*/,
@@ -271,5 +265,5 @@
                                      const QString &strCancelButtonText /* = QString()*/) const
 {
-    return question(pParent, enmType, strMessage, strHelpKeyword, pcszAutoConfirmId,
+    return question(pParent, enmType, strMessage, pcszAutoConfirmId,
                     AlertButton_Choice1,
                     AlertButton_Choice2 | AlertButtonOption_Default,
@@ -283,5 +277,4 @@
                                        const QString &strMessage,
                                        const QString &strOptionText,
-                                       const QString &strHelpKeyword,
                                        bool fDefaultOptionValue /* = true */,
                                        int iButton1 /* = 0*/,
@@ -330,5 +323,5 @@
     /* Create message-box: */
     QWidget *pBoxParent = windowManager().realParentWindow(pParent ? pParent : windowManager().mainWindowShown());
-    QPointer<QIMessageBox> pBox = new QIMessageBox(strTitle, strMessage, strHelpKeyword, icon,
+    QPointer<QIMessageBox> pBox = new QIMessageBox(strTitle, strMessage, icon,
                                                    iButton1, iButton2, iButton3, pBoxParent);
     windowManager().registerNewParent(pBox, pBoxParent);
@@ -671,5 +664,4 @@
                              "<p>Would you like to automatically rename it?</p>")
                              .arg(strName, strGroupName),
-                          QString() /* = QString() */,
                           0 /* auto-confirm id */,
                           tr("Rename"));
@@ -695,5 +687,4 @@
                              "<p><b>%1</b></p><p>Do you wish to proceed?</p>")
                              .arg(names.join(", ")),
-                          QString() /* help keyword */,
                           0 /* auto-confirm id */,
                           tr("Remove") /* ok button text */,
@@ -767,5 +758,5 @@
     return cInacessibleMachineCount == machines.size() ?
            message(0, MessageType_Question,
-                   strText, QString(), QString() /* help keyword */,
+                   strText, QString(),
                    0 /* auto-confirm id */,
                    AlertButton_Ok,
@@ -774,5 +765,5 @@
                    tr("Remove")) :
            message(0, MessageType_Question,
-                   strText, QString(), QString() /* help keyword */,
+                   strText, QString(),
                    0 /* auto-confirm id */,
                    AlertButton_Choice1,
@@ -802,5 +793,5 @@
     /* Prepare message itself: */
     return message(0, MessageType_Question,
-                   strText, QString(), QString() /* help keyword */,
+                   strText, QString(),
                    0 /* auto-confirm id */,
                    AlertButton_Choice1,
@@ -852,5 +843,4 @@
                              "see which files are inaccessible, or press <b>Ignore</b> to "
                              "ignore this message.</p>"),
-                          QString() /* help keyword */,
                           "warnAboutInaccessibleMedia",
                           tr("Check", "inaccessible media message box"), tr("Ignore"));
@@ -865,5 +855,4 @@
                              "the machine without doing a proper shutdown of the guest OS.</p>")
                              .arg(strNames),
-                          QString() /* help keyword */,
                           0 /* auto-confirm id */,
                           tr("Discard", "saved state"));
@@ -876,5 +865,4 @@
                              "of the following virtual machines?</p><p><b>%1</b></p>")
                              .arg(strNames),
-                          QString() /* help keyword */,
                           0 /* auto-confirm id */,
                           tr("Terminate", "cloud instance"));
@@ -888,5 +876,4 @@
                              "in applications running inside it to be lost.</p>")
                              .arg(strNames),
-                          QString() /* help keyword */,
                           "confirmResetMachine" /* auto-confirm id */,
                           tr("Reset", "machine"));
@@ -899,5 +886,4 @@
                              "to the following virtual machines?</p><p><b>%1</b></p>")
                              .arg(strNames),
-                          QString() /* help keyword */,
                           "confirmACPIShutdownMachine" /* auto-confirm id */,
                           tr("ACPI Shutdown", "machine"));
@@ -911,5 +897,4 @@
                              "running inside it to be lost.</p>")
                              .arg(strNames),
-                          QString() /* help keyword */,
                           "confirmPowerOffMachine" /* auto-confirm id */,
                           tr("Power Off", "machine"));
@@ -1138,5 +1123,4 @@
                                 .arg(strSnapshotName),
                              tr("Create a snapshot of the current machine state"),
-                             QString() /* Help keyword */,
                              !gEDataManager->messagesWithInvertedOption().contains("confirmSnapshotRestoring"),
                              AlertButton_Ok,
@@ -1148,5 +1132,4 @@
                       .arg(strSnapshotName),
                    QString() /* details */,
-                   QString() /* help keyword */,
                    0 /* auto-confirm id */,
                    AlertButton_Ok,
@@ -1164,5 +1147,4 @@
                              "</p>Are you sure you want to delete the selected snapshot <b>%1</b>?</p>")
                              .arg(strSnapshotName),
-                          QString() /* help keyword */,
                           0 /* auto-confirm id */,
                           tr("Delete") /* ok button text */,
@@ -1182,5 +1164,4 @@
                               "the snapshot at your own risk.</p>")
                               .arg(strSnapshotName, strTargetImageName, strTargetImageMaxSize, strTargetFileSystemFree),
-                          QString() /* help keyword */,
                           0 /* auto-confirm id */,
                           tr("Delete") /* ok button text */,
@@ -1292,5 +1273,4 @@
                              "type.</p>")
                              .arg(strName),
-                          QString() /* help keyword */,
                           0 /* auto-confirm id */,
                           tr("Remove") /* ok button text */,
@@ -1341,5 +1321,4 @@
                              "You currently have unsaved setting changes.</p>"
                              "<p>Would you like to reload the changed settings or to keep your own changes?</p>"),
-                          QString() /* help keyword */,
                           0 /* auto-confirm id */,
                           tr("Reload settings"), tr("Keep changes"));
@@ -1352,5 +1331,4 @@
                              "<p>You will not be able to insert any optical disks or ISO images "
                              "or install the Guest Additions without it!</p>"),
-                          QString() /* help keyword */,
                           0 /* auto-confirm id */,
                           tr("&Remove", "medium") /* ok button text */,
@@ -1452,5 +1430,4 @@
                           tr("<p>There are unsaved changes in the port forwarding configuration.</p>"
                              "<p>If you proceed your changes will be discarded.</p>"),
-                          QString() /* help keyword */,
                           0 /* auto-confirm id */,
                           QString() /* ok button text */,
@@ -1560,5 +1537,4 @@
                                "<p>This will detach it from the following virtual machine(s): <b>%2</b>.</p>")
                                .arg(medium.location(), usage.join(", ")),
-                            QString() /* help keyword */,
                             0 /* auto-confirm id */,
                             tr("Release", "detach medium"))
@@ -1569,5 +1545,4 @@
                                "<p>This will detach it from the following virtual machine(s): <b>%2</b>.</p>")
                                .arg(medium.location(), usage.join(", ")),
-                            QString() /* help keyword */,
                             0 /* auto-confirm id */,
                             tr("Release", "detach medium"));
@@ -1621,5 +1596,4 @@
     return questionBinary(pParent, MessageType_Question,
                           strMessage.arg(medium.location()),
-                          QString() /* help keyword */,
                           0 /* auto-confirm id */,
                           tr("Remove", "medium") /* ok button text */,
@@ -1641,5 +1615,4 @@
                               "disk to the list later again.</p>")
                               .arg(strLocation),
-                           QString() /* help keyword */,
                            0 /* auto-confirm id */,
                            tr("Delete", "hard disk storage"),
@@ -1756,5 +1729,4 @@
                                  strMessage.arg(medium.isHostDrive() ? medium.name() : medium.location(), CMachine(machine).GetName()),
                                  UIErrorString::formatErrorInfo(machine),
-                                 QString() /* help keyword */,
                                  0 /* Auto Confirm ID */,
                                  tr("Force Unmount"));
@@ -1812,5 +1784,4 @@
                              "name or a different adapter attachment type.</p>")
                              .arg(strName),
-                          QString() /* help keyword */,
                           0 /* auto-confirm id */,
                           tr("Remove") /* ok button text */,
@@ -2183,5 +2154,4 @@
                           tr("<p>Do you want to remove the cloud profile <nobr><b>%1</b>?</nobr></p>")
                              .arg(strName),
-                          QString() /* help keyword */,
                           0 /* auto-confirm id */,
                           tr("Remove") /* ok button text */,
@@ -2195,5 +2165,4 @@
                           tr("<p>Do you want to import cloud profiles from external files?</p>"
                              "<p>VirtualBox cloud profiles will be overwritten and their data will be lost.</p>"),
-                          QString() /* help keyword */,
                           0 /* auto-confirm id */,
                           tr("Import") /* ok button text */,
@@ -2244,5 +2213,4 @@
                        "You can choose to <b>Accept</b> or <b>Reject</b> them automatically "
                        "or cancel to keep the dialog opened.</p>"),
-                    QString() /* help keyword */,
                     0 /* auto-confirm id */,
                     AlertButton_Choice1,
@@ -2258,5 +2226,4 @@
                           tr("<p>Do you want to remove the cloud console application <nobr><b>%1</b>?</nobr></p>")
                              .arg(strName),
-                          QString() /* help keyword */,
                           0 /* auto-confirm id */,
                           tr("Remove") /* ok button text */,
@@ -2270,5 +2237,4 @@
                           tr("<p>Do you want to remove the cloud console profile <nobr><b>%1</b>?</nobr></p>")
                              .arg(strName),
-                          QString() /* help keyword */,
                           0 /* auto-confirm id */,
                           tr("Remove") /* ok button text */,
@@ -2284,5 +2250,4 @@
                              "until you add one. In the mean time you will only be able to start the "
                              "machine using a virtual optical disk or from the network."),
-                          QString() /* help keyword */,
                           0 /* auto-confirm id */,
                           tr("Continue", "no hard disk attached"),
@@ -2519,5 +2484,4 @@
                              "how many machines are in the list and doesn't need to be told).", machineNames.size())
                              .arg(machineNames.join(", ")),
-                          QString() /* help keyword */,
                           0 /* auto-confirm id */,
                           tr("Continue"));
@@ -2686,5 +2650,4 @@
                              "so it is recommended to press <b>OK</b> now.</p>")
                              .arg(strLogFolder),
-                          QString() /* help keyword */,
                           0 /* auto-confirm id */,
                           QIMessageBox::tr("OK"),
@@ -2719,5 +2682,4 @@
                                  "Your 64-bit guest will fail to detect a 64-bit CPU and will not be able to boot.</p>"
                                  "<p>Please ensure that you have enabled VT-x/AMD-V properly in the BIOS of your host computer.</p>"),
-                              QString() /* help keyword */,
                               0 /* auto-confirm id */,
                               tr("Close VM"), tr("Continue"));
@@ -2726,5 +2688,4 @@
                               tr("<p>VT-x/AMD-V hardware acceleration is not available on your system. "
                                  "Your 64-bit guest will fail to detect a 64-bit CPU and will not be able to boot."),
-                              QString() /* help keyword */,
                               0 /* auto-confirm id */,
                               tr("Close VM"), tr("Continue"));
@@ -2738,5 +2699,4 @@
                                  "Certain guests (e.g. OS/2 and QNX) require this feature.</p>"
                                  "<p>Please ensure that you have enabled VT-x/AMD-V properly in the BIOS of your host computer.</p>"),
-                              QString() /* help keyword */,
                               0 /* auto-confirm id */,
                               tr("Close VM"), tr("Continue"));
@@ -2745,5 +2705,4 @@
                               tr("<p>VT-x/AMD-V hardware acceleration is not available on your system. "
                                  "Certain guests (e.g. OS/2 and QNX) require this feature and will fail to boot without it.</p>"),
-                              QString() /* help keyword */,
                               0 /* auto-confirm id */,
                               tr("Close VM"), tr("Continue"));
@@ -2757,5 +2716,4 @@
                              "<p>You can either change the machine's network settings or stop the machine.</p>")
                              .arg(strMachineName, strIfNames),
-                          QString() /* help keyword */,
                           0 /* auto-confirm id */,
                           tr("Change Network Settings"), tr("Close VM"));
@@ -2792,5 +2750,4 @@
                       tr("<p>The host key is currently defined as <b>%1</b>.</p>", "additional message box paragraph")
                          .arg(UIHostCombo::toReadableString(gEDataManager->hostKeyCombination())),
-                      QString() /* help keyword */,
                       "confirmInputCapture",
                       AlertButton_Ok | AlertButtonOption_Default,
@@ -2813,5 +2770,4 @@
                              "You can access it by pressing <b>Host+Home</b>.</p>")
                              .arg(strHotKey, UIHostCombo::toReadableString(gEDataManager->hostKeyCombination())),
-                          QString() /* help keyword */,
                           "confirmGoingFullscreen",
                           tr("Switch"));
@@ -2827,5 +2783,4 @@
                              "You can access it by pressing <b>Host+Home</b>.</p>")
                              .arg(strHotKey, UIHostCombo::toReadableString(gEDataManager->hostKeyCombination())),
-                          QString() /* help keyword */,
                           "confirmGoingSeamless",
                           tr("Switch"));
@@ -2841,5 +2796,4 @@
                              "You can access it by pressing <b>Host+Home</b>.</p>")
                              .arg(strHotKey, UIHostCombo::toReadableString(gEDataManager->hostKeyCombination())),
-                          QString() /* help keyword */,
                           "confirmGoingScale",
                           tr("Switch"));
@@ -2853,5 +2807,4 @@
                              "<p>Press <b>Ignore</b> to switch to full-screen mode anyway or press <b>Cancel</b> to cancel the operation.</p>")
                              .arg(UICommon::formatSize(uMinVRAM)),
-                          QString() /* help keyword */,
                           0 /* auto-confirm id */,
                           tr("Ignore"));
@@ -2875,5 +2828,4 @@
                              "<p>Press <b>Ignore</b> to switch the screen anyway or press <b>Cancel</b> to cancel the operation.</p>")
                              .arg(UICommon::formatSize(uMinVRAM)),
-                          QString() /* help keyword */,
                           0 /* auto-confirm id */,
                           tr("Ignore"));
@@ -2940,5 +2892,4 @@
                           tr("<p>Could not find the <b>VirtualBox Guest Additions</b> disk image file.</p>"
                              "<p>Do you wish to download this disk image file from the Internet?</p>"),
-                          QString() /* help keyword */,
                           0 /* auto-confirm id */,
                           tr("Download"));
@@ -2951,5 +2902,4 @@
                              "from <nobr><a href=\"%1\">%1</a></nobr> (size %2 bytes)?</p>")
                              .arg(strUrl, QLocale(UICommon::languageId()).toString(uSize)),
-                          QString() /* help keyword */,
                           0 /* auto-confirm id */,
                           tr("Download"));
@@ -2974,5 +2924,4 @@
                              "<p>Do you wish to register this disk image file and insert it into the virtual optical drive?</p>")
                              .arg(strUrl, strSrc),
-                          QString() /* help keyword */,
                           0 /* auto-confirm id */,
                           tr("Insert", "additions"));
@@ -3004,5 +2953,4 @@
                              "<p>Do you wish to download this file from the Internet?</p>")
                              .arg(strMissedLocation),
-                          QString() /* help keyword */,
                           0 /* auto-confirm id */,
                           tr("Download"));
@@ -3015,5 +2963,4 @@
                              "from <nobr><a href=\"%1\">%1</a></nobr> (size %2 bytes)?</p>")
                              .arg(strURL, QLocale(UICommon::languageId()).toString(uSize)),
-                          QString() /* help keyword */,
                           0 /* auto-confirm id */,
                           tr("Download"));
@@ -3045,5 +2992,4 @@
                              "<p>Do you wish to download latest one from the Internet?</p>")
                              .arg(strExtPackVersion).arg(strExtPackName),
-                          QString() /* help keyword */,
                           0 /* auto-confirm id */,
                           tr("Download"));
@@ -3056,5 +3002,4 @@
                              "from <nobr><a href=\"%2\">%2</a></nobr> (size %3 bytes)?</p>")
                              .arg(strExtPackName, strURL, QLocale(UICommon::languageId()).toString(uSize)),
-                          QString() /* help keyword */,
                           0 /* auto-confirm id */,
                           tr("Download"));
@@ -3079,5 +3024,4 @@
                              "<p>Do you wish to install this extension pack?</p>")
                              .arg(strExtPackName, strFrom, strTo),
-                          QString() /* help keyword */,
                           0 /* auto-confirm id */,
                           tr("Install", "extension pack"));
@@ -3100,5 +3044,4 @@
                           tr("Do you want to delete the downloaded file <nobr><b>%1</b></nobr>?")
                              .arg(strTo),
-                          QString() /* help keyword */,
                           0 /* auto-confirm id */,
                           tr("Delete", "extension pack"));
@@ -3110,5 +3053,4 @@
                           tr("Do you want to delete following list of files <nobr><b>%1</b></nobr>?")
                              .arg(strFiles.join(",")),
-                          QString() /* help keyword */,
                           0 /* auto-confirm id */,
                           tr("Delete", "extension pack"));
@@ -3130,5 +3072,4 @@
                              "</table></p>")
                              .arg(strPackName).arg(strPackVersion).arg(strPackDescription),
-                          QString() /* help keyword */,
                           0 /* auto-confirm id */,
                           tr("Install", "extension pack"));
@@ -3163,5 +3104,4 @@
                                 "</table></p>")
                                 .arg(strBelehrung).arg(strPackName).arg(strPackVersionNew).arg(strPackVersionOld).arg(strPackDescription),
-                             QString() /* help keyword */,
                              0 /* auto-confirm id */,
                              tr("&Upgrade"));
@@ -3177,5 +3117,4 @@
                                 "</table></p>")
                                 .arg(strBelehrung).arg(strPackName).arg(strPackVersionNew).arg(strPackVersionOld).arg(strPackDescription),
-                             QString() /* help keyword */,
                              0 /* auto-confirm id */,
                              tr("&Downgrade"));
@@ -3190,5 +3129,4 @@
                                 "</table></p>")
                                 .arg(strBelehrung).arg(strPackName).arg(strPackVersionOld).arg(strPackDescription),
-                             QString() /* help keyword */,
                              0 /* auto-confirm id */,
                              tr("&Reinstall"));
@@ -3202,5 +3140,4 @@
                              "<p>Are you sure you want to proceed?</p>")
                              .arg(strPackName),
-                          QString() /* help keyword */,
                           0 /* auto-confirm id */,
                           tr("&Remove") /* ok button text */,
@@ -3335,5 +3272,4 @@
                              "Replacing it will overwrite its contents.")
                              .arg(strPath),
-                          QString() /* help keyword */,
                           0 /* auto-confirm id */,
                           QString() /* ok button text */,
@@ -3353,5 +3289,4 @@
                                  "Replacing them will overwrite their contents.")
                                  .arg(QStringList(strPaths.toList()).join("<br />")),
-                              QString() /* help keyword */,
                               0 /* auto-confirm id */,
                               QString() /* ok button text */,
@@ -3499,5 +3434,5 @@
 
 void UIMessageCenter::sltShowMessageBox(QWidget *pParent, MessageType enmType,
-                                        const QString &strMessage, const QString &strDetails, const QString &strHelpKeyword,
+                                        const QString &strMessage, const QString &strDetails,
                                         int iButton1, int iButton2, int iButton3,
                                         const QString &strButtonText1, const QString &strButtonText2, const QString &strButtonText3,
@@ -3506,5 +3441,5 @@
     /* Now we can show a message-box directly: */
     showMessageBox(pParent, enmType,
-                   strMessage, strDetails, strHelpKeyword,
+                   strMessage, strDetails,
                    iButton1, iButton2, iButton3,
                    strButtonText1, strButtonText2, strButtonText3,
@@ -3568,5 +3503,5 @@
 
 int UIMessageCenter::showMessageBox(QWidget *pParent, MessageType enmType,
-                                    const QString &strMessage, const QString &strDetails, const QString &strHelpKeyword,
+                                    const QString &strMessage, const QString &strDetails,
                                     int iButton1, int iButton2, int iButton3,
                                     const QString &strButtonText1, const QString &strButtonText2, const QString &strButtonText3,
@@ -3634,5 +3569,5 @@
     /* Create message-box: */
     QWidget *pMessageBoxParent = windowManager().realParentWindow(pParent ? pParent : windowManager().mainWindowShown());
-    QPointer<QIMessageBox> pMessageBox = new QIMessageBox(title, strMessage, strHelpKeyword, icon,
+    QPointer<QIMessageBox> pMessageBox = new QIMessageBox(title, strMessage, icon,
                                                           iButton1, iButton2, iButton3,
                                                           pMessageBoxParent);
@@ -3715,5 +3650,5 @@
 #if defined(VBOX_WITH_QHELP_VIEWER)
     sltHandleHelpRequestWithKeyword(uiCommon().helpKeyword(sender()));
-#endif
+#endif /* #if (QT_VERSION >= QT_VERSION_CHECK(5, 9, 0))&& (QT_VERSION >= QT_VERSION_CHECK(5, 9, 0)) */
 }
 
@@ -3728,4 +3663,4 @@
 #else
     Q_UNUSED(strHelpKeyword);
-# endif
-}
+# endif /* #if (QT_VERSION >= QT_VERSION_CHECK(5, 9, 0))&& (QT_VERSION >= QT_VERSION_CHECK(5, 9, 0)) */
+}
Index: trunk/src/VBox/Frontends/VirtualBox/src/globals/UIMessageCenter.h
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox/src/globals/UIMessageCenter.h	(revision 89946)
+++ trunk/src/VBox/Frontends/VirtualBox/src/globals/UIMessageCenter.h	(revision 89950)
@@ -68,5 +68,4 @@
       * @param  strMessage        Brings the message.
       * @param  strDetails        Brings the details.
-      * @param  strHelpKeyword    Brings the help keyword.
       * @param  iButton1          Brings the button 1 type.
       * @param  iButton2          Brings the button 2 type.
@@ -77,5 +76,5 @@
       * @param  strAutoConfirmId  Brings whether this message can be auto-confirmed. */
     void sigToShowMessageBox(QWidget *pParent, MessageType enmType,
-                             const QString &strMessage, const QString &strDetails, const QString &strHelpKeyword,
+                             const QString &strMessage, const QString &strDetails,
                              int iButton1, int iButton2, int iButton3,
                              const QString &strButtonText1, const QString &strButtonText2, const QString &strButtonText3,
@@ -99,5 +98,4 @@
       * @param  strMessage         Brings the message.
       * @param  strDetails         Brings the details.
-      * @param  strHelpKeyword     Brings the help keyword
       * @param  pcszAutoConfirmId  Brings the auto-confirm ID.
       * @param  iButton1           Brings the button 1 type.
@@ -108,5 +106,5 @@
       * @param  strButtonText3     Brings the button 3 text. */
     int message(QWidget *pParent, MessageType enmType,
-                const QString &strMessage, const QString &strDetails, const QString &strHelpKeyword,
+                const QString &strMessage, const QString &strDetails,
                 const char *pcszAutoConfirmId = 0,
                 int iButton1 = 0, int iButton2 = 0, int iButton3 = 0,
@@ -121,10 +119,8 @@
       * @param  strMessage         Brings the message.
       * @param  strDetails         Brings the details.
-      * @param  strHelpKeyword     Brings the help keyword
       * @param  pcszAutoConfirmId  Brings the auto-confirm ID. */
     void error(QWidget *pParent, MessageType enmType,
                const QString &strMessage,
                const QString &strDetails,
-               const QString &strHelpKeyword = QString(),
                const char *pcszAutoConfirmId = 0) const;
 
@@ -135,5 +131,4 @@
       * @param  strMessage           Brings the message.
       * @param  strDetails           Brings the details.
-      * @param  strHelpKeyword       Brings the help keyword
       * @param  pcszAutoConfirmId    Brings the auto-confirm ID.
       * @param  strOkButtonText      Brings the Ok button text.
@@ -142,5 +137,4 @@
                            const QString &strMessage,
                            const QString &strDetails,
-                           const QString &strHelpKeyword,
                            const char *pcszAutoConfirmId = 0,
                            const QString &strOkButtonText = QString(),
@@ -162,5 +156,4 @@
       * @param  enmType            Brings the message-box type.
       * @param  strMessage         Brings the message.
-      * @param  strHelpKeyword     Brings the help keyword.
       * @param  pcszAutoConfirmId  Brings the auto-confirm ID.
       * @param  iButton1           Brings the button 1 type.
@@ -172,5 +165,4 @@
     int question(QWidget *pParent, MessageType enmType,
                  const QString &strMessage,
-                 const QString &strHelpKeyword,
                  const char *pcszAutoConfirmId = 0,
                  int iButton1 = 0, int iButton2 = 0, int iButton3 = 0,
@@ -184,5 +176,4 @@
       * @param  enmType              Brings the message-box type.
       * @param  strMessage           Brings the message.
-      * @param  strHelpKeyword       Brings the help keyword.
       * @param  pcszAutoConfirmId    Brings the auto-confirm ID.
       * @param  strOkButtonText      Brings the button 1 text.
@@ -191,5 +182,4 @@
     bool questionBinary(QWidget *pParent, MessageType enmType,
                         const QString &strMessage,
-                        const QString &strHelpKeyword = QString(),
                         const char *pcszAutoConfirmId = 0,
                         const QString &strOkButtonText = QString(),
@@ -202,5 +192,4 @@
       * @param  enmType               Brings the message-box type.
       * @param  strMessage            Brings the message.
-      * @param  strHelpKeyword        Brings the help keyword.
       * @param  pcszAutoConfirmId     Brings the auto-confirm ID.
       * @param  strChoice1ButtonText  Brings the button 1 text.
@@ -209,5 +198,4 @@
     int questionTrinary(QWidget *pParent, MessageType enmType,
                         const QString &strMessage,
-                        const QString &strHelpKeyword = QString(),
                         const char *pcszAutoConfirmId = 0,
                         const QString &strChoice1ButtonText = QString(),
@@ -220,5 +208,4 @@
       * @param  strMessage           Brings the message.
       * @param  strOptionText        Brings the option text.
-      * @param  strHelpKeyword       Brings the help keyword which is used in context sensitive help.
       * @param  fDefaultOptionValue  Brings the default option value.
       * @param  iButton1             Brings the button 1 type.
@@ -231,5 +218,4 @@
                           const QString &strMessage,
                           const QString &strOptionText,
-                          const QString &strHelpKeyword,
                           bool fDefaultOptionValue = true,
                           int iButton1 = 0, int iButton2 = 0, int iButton3 = 0,
@@ -601,5 +587,4 @@
       * @param  enmType           Brings the message-box type.
       * @param  strMessage        Brings the message.
-      * @param  strMessage        Brings the help keyword.
       * @param  strDetails        Brings the details.
       * @param  iButton1          Brings the button 1 type.
@@ -611,5 +596,5 @@
       * @param  strAutoConfirmId  Brings whether this message can be auto-confirmed. */
     void sltShowMessageBox(QWidget *pParent, MessageType enmType,
-                           const QString &strMessage, const QString &strDetails, const QString &strHelpKeyword,
+                           const QString &strMessage, const QString &strDetails,
                            int iButton1, int iButton2, int iButton3,
                            const QString &strButtonText1, const QString &strButtonText2, const QString &strButtonText3,
@@ -633,5 +618,4 @@
       * @param  strMessage        Brings the message.
       * @param  strDetails        Brings the details.
-      * @param  strHelpKeyword    Brings the help keyword
       * @param  iButton1          Brings the button 1 type.
       * @param  iButton2          Brings the button 2 type.
@@ -642,5 +626,5 @@
       * @param  strAutoConfirmId  Brings whether this message can be auto-confirmed. */
     int showMessageBox(QWidget *pParent, MessageType type,
-                       const QString &strMessage, const QString &strDetails, const QString &strHelpKeyword,
+                       const QString &strMessage, const QString &strDetails,
                        int iButton1, int iButton2, int iButton3,
                        const QString &strButtonText1, const QString &strButtonText2, const QString &strButtonText3,
Index: trunk/src/VBox/Frontends/VirtualBox/src/softkeyboard/UISoftKeyboard.cpp
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox/src/softkeyboard/UISoftKeyboard.cpp	(revision 89946)
+++ trunk/src/VBox/Frontends/VirtualBox/src/softkeyboard/UISoftKeyboard.cpp	(revision 89950)
@@ -2715,5 +2715,4 @@
         if (!msgCenter().questionBinary(this, MessageType_Question,
                                         QString(UISoftKeyboard::tr("This will delete the keyboard layout file as well. Proceed?")),
-                                        QString() /* help keyword */,
                                         0 /* auto-confirm id */,
                                         QString("Delete") /* ok button text */,