Index: trunk/src/VBox/Frontends/VirtualBox/src/globals/UIMessageCenter.cpp
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox/src/globals/UIMessageCenter.cpp	(revision 89950)
+++ trunk/src/VBox/Frontends/VirtualBox/src/globals/UIMessageCenter.cpp	(revision 89954)
@@ -162,5 +162,6 @@
                              const QString &strButtonText1 /* = QString() */,
                              const QString &strButtonText2 /* = QString() */,
-                             const QString &strButtonText3 /* = QString() */) const
+                             const QString &strButtonText3 /* = QString() */,
+                             const QString &strHelpKeyword /* = QString() */) const
 {
     /* If this is NOT a GUI thread: */
@@ -173,5 +174,5 @@
                                  iButton1, iButton2, iButton3,
                                  strButtonText1, strButtonText2, strButtonText3,
-                                 QString(pcszAutoConfirmId));
+                                 QString(pcszAutoConfirmId), strHelpKeyword);
         /* Inter-thread communications are not yet implemented: */
         return 0;
@@ -182,5 +183,5 @@
                           iButton1, iButton2, iButton3,
                           strButtonText1, strButtonText2, strButtonText3,
-                          QString(pcszAutoConfirmId));
+                          QString(pcszAutoConfirmId), strHelpKeyword);
 }
 
@@ -188,8 +189,10 @@
                            const QString &strMessage,
                            const QString &strDetails,
-                           const char *pcszAutoConfirmId /* = 0*/) const
+                           const char *pcszAutoConfirmId /* = 0*/,
+                           const QString &strHelpKeyword /* = QString() */) const
 {
     message(pParent, enmType, strMessage, strDetails, pcszAutoConfirmId,
-            AlertButton_Ok | AlertButtonOption_Default | AlertButtonOption_Escape);
+            AlertButton_Ok | AlertButtonOption_Default | AlertButtonOption_Escape, 0 /* Button 2 */, 0 /* Button 3 */,
+            QString() /* strButtonText1 */, QString() /* strButtonText2 */, QString() /* strButtonText3 */, strHelpKeyword);
 }
 
@@ -630,5 +633,6 @@
     error(pParent, MessageType_Warning,
           tr("Failed to enumerate host USB devices."),
-          UIErrorString::formatErrorInfo(comHost), "USBEnumerationWarning");
+          UIErrorString::formatErrorInfo(comHost), "USBEnumerationWarning",
+          "install-linux-vboxusers" /* help keyword */);
 }
 
@@ -3437,5 +3441,5 @@
                                         int iButton1, int iButton2, int iButton3,
                                         const QString &strButtonText1, const QString &strButtonText2, const QString &strButtonText3,
-                                        const QString &strAutoConfirmId) const
+                                        const QString &strAutoConfirmId, const QString &strHelpKeyword) const
 {
     /* Now we can show a message-box directly: */
@@ -3444,5 +3448,5 @@
                    iButton1, iButton2, iButton3,
                    strButtonText1, strButtonText2, strButtonText3,
-                   strAutoConfirmId);
+                   strAutoConfirmId, strHelpKeyword);
 }
 
@@ -3506,5 +3510,5 @@
                                     int iButton1, int iButton2, int iButton3,
                                     const QString &strButtonText1, const QString &strButtonText2, const QString &strButtonText3,
-                                    const QString &strAutoConfirmId) const
+                                    const QString &strAutoConfirmId, const QString &strHelpKeyword) const
 {
     /* Choose the 'default' button: */
@@ -3571,5 +3575,5 @@
     QPointer<QIMessageBox> pMessageBox = new QIMessageBox(title, strMessage, icon,
                                                           iButton1, iButton2, iButton3,
-                                                          pMessageBoxParent);
+                                                          pMessageBoxParent, strHelpKeyword);
     windowManager().registerNewParent(pMessageBox, pMessageBoxParent);
 
Index: trunk/src/VBox/Frontends/VirtualBox/src/globals/UIMessageCenter.h
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox/src/globals/UIMessageCenter.h	(revision 89950)
+++ trunk/src/VBox/Frontends/VirtualBox/src/globals/UIMessageCenter.h	(revision 89954)
@@ -79,5 +79,5 @@
                              int iButton1, int iButton2, int iButton3,
                              const QString &strButtonText1, const QString &strButtonText2, const QString &strButtonText3,
-                             const QString &strAutoConfirmId) const;
+                             const QString &strAutoConfirmId, const QString &strHelpKeyword) const;
 
 public:
@@ -104,5 +104,6 @@
       * @param  strButtonText1     Brings the button 1 text.
       * @param  strButtonText2     Brings the button 2 text.
-      * @param  strButtonText3     Brings the button 3 text. */
+      * @param  strButtonText3     Brings the button 3 text.
+      * @param  strHelpKeyword     Brings the help keyword string. */
     int message(QWidget *pParent, MessageType enmType,
                 const QString &strMessage, const QString &strDetails,
@@ -111,5 +112,6 @@
                 const QString &strButtonText1 = QString(),
                 const QString &strButtonText2 = QString(),
-                const QString &strButtonText3 = QString()) const;
+                const QString &strButtonText3 = QString(),
+                const QString &strHelpKeyword = QString()) const;
 
     /** Shows an 'Error' type of 'Message'.
@@ -119,9 +121,11 @@
       * @param  strMessage         Brings the message.
       * @param  strDetails         Brings the details.
-      * @param  pcszAutoConfirmId  Brings the auto-confirm ID. */
+      * @param  pcszAutoConfirmId  Brings the auto-confirm ID.
+      * @param  strHelpKeyword     Brings the help keyword string. */
     void error(QWidget *pParent, MessageType enmType,
                const QString &strMessage,
                const QString &strDetails,
-               const char *pcszAutoConfirmId = 0) const;
+               const char *pcszAutoConfirmId = 0,
+               const QString &strHelpKeyword = QString()) const;
 
     /** Shows an 'Error with Question' type of 'Message'.
@@ -594,10 +598,11 @@
       * @param  strButtonText2    Brings the button 2 text.
       * @param  strButtonText3    Brings the button 3 text.
-      * @param  strAutoConfirmId  Brings whether this message can be auto-confirmed. */
+      * @param  strAutoConfirmId  Brings whether this message can be auto-confirmed.
+      * @param  strHelpKeyword    Brings the help keyword string. */
     void sltShowMessageBox(QWidget *pParent, MessageType enmType,
                            const QString &strMessage, const QString &strDetails,
                            int iButton1, int iButton2, int iButton3,
                            const QString &strButtonText1, const QString &strButtonText2, const QString &strButtonText3,
-                           const QString &strAutoConfirmId) const;
+                           const QString &strAutoConfirmId, const QString &strHelpKeyword) const;
 
 private:
@@ -624,10 +629,11 @@
       * @param  strButtonText2    Brings the button 2 text.
       * @param  strButtonText3    Brings the button 3 text.
-      * @param  strAutoConfirmId  Brings whether this message can be auto-confirmed. */
+      * @param  strAutoConfirmId  Brings whether this message can be auto-confirmed.
+      * @param  strHelpKeyword    Brings the help keyowrd. */
     int showMessageBox(QWidget *pParent, MessageType type,
                        const QString &strMessage, const QString &strDetails,
                        int iButton1, int iButton2, int iButton3,
                        const QString &strButtonText1, const QString &strButtonText2, const QString &strButtonText3,
-                       const QString &strAutoConfirmId) const;
+                       const QString &strAutoConfirmId, const QString &strHelpKeyword) const;
     void showHelpBrowser(const QString &strHelpFilePath, QWidget *pParent = 0);
 